searchData={"content_type":"text/markdown","items":[{"doc":"This module provides Amqpx-related types.","ref":"Amqpx.html","title":"Amqpx","type":"module"},{"doc":"","ref":"Amqpx.html#t:argument_type/0","title":"Amqpx.argument_type/0","type":"type"},{"doc":"","ref":"Amqpx.html#t:arguments/0","title":"Amqpx.arguments/0","type":"type"},{"doc":"Implements a jittered backoff strategy","ref":"Amqpx.Backoff.Jittered.html","title":"Amqpx.Backoff.Jittered","type":"module"},{"doc":"","ref":"Amqpx.Backoff.Jittered.html#backoff/3","title":"Amqpx.Backoff.Jittered.backoff/3","type":"function"},{"doc":"Functions to publish, consume and acknowledge messages.","ref":"Amqpx.Basic.html","title":"Amqpx.Basic","type":"module"},{"doc":"Acknowledges one or more messages.","ref":"Amqpx.Basic.html#ack/3","title":"Amqpx.Basic.ack/3","type":"function"},{"doc":"* `:multiple` - If set, all messages up to the one specified by `delivery_tag`\n    are acknowledged. Defaults to `false`.","ref":"Amqpx.Basic.html#ack/3-options","title":"Options - Amqpx.Basic.ack/3","type":"function"},{"doc":"Stops the given consumer from consuming.\n\nThis method cancels a consumer. This does not affect already delivered messages, but it does\nmean the server will not send any more messages for that consumer. The client may receive an\narbitrary number of messages in between sending the cancel method and receiving the reply.\n\n`consumer_tag` identifies the \"subscription\" to cancel, that is, the subscription of a\nconsumer to a specific queue. The consumer tag is returned by `consume/4`.","ref":"Amqpx.Basic.html#cancel/3","title":"Amqpx.Basic.cancel/3","type":"function"},{"doc":"* `:no_wait` - If set, the cancel operation is asynchronous. Defaults to\n    `false`.","ref":"Amqpx.Basic.html#cancel/3-options","title":"Options - Amqpx.Basic.cancel/3","type":"function"},{"doc":"Removes the return handler, if it exists. Does nothing if there is no\nsuch handler.","ref":"Amqpx.Basic.html#cancel_return/1","title":"Amqpx.Basic.cancel_return/1","type":"function"},{"doc":"Registers a queue consumer process. The `pid` of the process can be set using\nthe `consumer_pid` argument and defaults to the calling process.\n\nThe consumer process will receive the following data structures:\n\n  * `{:basic_deliver, payload, meta}` - This is sent for each message consumed, where `payload` contains the message content and `meta` contains all the metadata set when sending with Basic.publish or additional info set by the broker;\n  * `{:basic_consume_ok, %{consumer_tag: consumer_tag}}` - Sent when the consumer process is registered with Basic.consume. The caller receives the same information as the return of Basic.consume;\n  * `{:basic_cancel, %{consumer_tag: consumer_tag, no_wait: no_wait}}` - Sent by the broker when the consumer is unexpectedly cancelled (such as after a queue deletion)\n  * `{:basic_cancel_ok, %{consumer_tag: consumer_tag}}` - Sent to the consumer process after a call to Basic.cancel","ref":"Amqpx.Basic.html#consume/4","title":"Amqpx.Basic.consume/4","type":"function"},{"doc":"* `:consumer_tag` - Specifies the consumer tag for this consumer (as a string).\n    This tag is local to the given channel `chan`, so different channels can have\n    consumers that use the same consumer tag. If the given consumer tag is `\"\"`,\n    then the server autogenerates the tag. Defaults to `\"\"`.\n  * `:no_local` - If set, the server won't send messages to the connection\n    that published them. Defaults to `false`.\n  * `:no_ack` - If set, the server will not expect message acks from the consumer and\n    will consider every message that it believes was delivered to the consumer as\n    acknowledged. Defaults to `false`, meaning that messages need to be acked\n    explicitly through `ack/3`.\n  * `:exclusive` - If set, requests exclusive consumer access, meaning that only\n    this consumer can consume from the given `queue`. Note that the client cannot\n    have exclusive access to a queue that already has consumers.\n  * `:no_wait` - If set, the consume operation is asynchronous. Defaults to\n    `false`.\n  * `:arguments` - A list of arguments to pass when consuming (of type `t:Amqpx.arguments/0`).\n    See the README for more information. Defaults to `[]`.","ref":"Amqpx.Basic.html#consume/4-options","title":"Options - Amqpx.Basic.consume/4","type":"function"},{"doc":"Polls a queue for an existing message.\n\nReturns the tuple `{:empty, meta}` if the queue is empty or the tuple `{:ok, payload, meta}` if at least\none message exists in the queue. The returned `meta` map includes the entry `:message_count` with the\ncurrent number of messages in the queue.\n\nReceiving messages by polling a queue is not as as efficient as subscribing a consumer to a queue,\nso consideration should be taken when receiving large volumes of messages.","ref":"Amqpx.Basic.html#get/3","title":"Amqpx.Basic.get/3","type":"function"},{"doc":"* `:no_ack` - If set, the broker is told that the received will not send an acknoledgement\n    of the message. Once the broker believes it has delivered the message, then it's free to\n    assume that the consuming application has taken responsibility for it. In general, a lot\n    of applications will not want these semantics, rather, they will want to explicitly\n    acknowledge the receipt of a message (through `ack/3`). Defaults to `false` (meaning\n    explicit acks).","ref":"Amqpx.Basic.html#get/3-options","title":"Options - Amqpx.Basic.get/3","type":"function"},{"doc":"Negative acknowledges of one or more messages.\n\nThis is a RabbitMQ specific extension to Amqpx 0.9.1. It is equivalent to `reject/3`, but allows\nrejecting multiple messages using the `multiple` option.","ref":"Amqpx.Basic.html#nack/3","title":"Amqpx.Basic.nack/3","type":"function"},{"doc":"* `:multiple` - If set, all messages up to the one specified by `delivery_tag`\n    are considered as not acknowledged by the server. Defaults to `false`.\n  * `:requeue` - If set, the message will be returned to the queue and redelivered\n    to the next available consumer. Defaults to `true`.","ref":"Amqpx.Basic.html#nack/3-options","title":"Options - Amqpx.Basic.nack/3","type":"function"},{"doc":"Publishes a message to an Exchange.\n\nThis method publishes a message to a specific exchange. The message will be routed\nto queues as defined by the exchange configuration and distributed to any subscribers.\n\nThe parameter `exchange` specifies the name of the exchange to publish to. If set to\nempty string, it publishes to the default exchange.\nThe `routing_key` parameter specifies the routing key for the message.\n\nThe `payload` parameter specifies the message content as a binary.\n\nIn addition to the previous parameters, the following options can be used:","ref":"Amqpx.Basic.html#publish/5","title":"Amqpx.Basic.publish/5","type":"function"},{"doc":"* `:mandatory` - If set, returns an error if the broker can't route the message to a queue (default `false`);\n  * `:immediate` - If set, returns an error if the broker can't deliver the message to a consumer immediately (default `false`);\n  * `:content_type` - MIME Content type;\n  * `:content_encoding` - MIME Content encoding;\n  * `:headers` - Message headers of type `t:Amqpx.arguments/0`. Can be used with headers Exchanges;\n  * `:persistent` - If set, uses persistent delivery mode. Messages marked as `persistent` that are delivered to `durable`                     queues will be logged to disk;\n  * `:correlation_id` - application correlation identifier;\n  * `:priority` - message priority, ranging from 0 to 9;\n  * `:reply_to` - name of the reply queue;\n  * `:expiration` - how long the message is valid (in milliseconds);\n  * `:message_id` - message identifier;\n  * `:timestamp` - timestamp associated with this message (epoch time);\n  * `:type` - message type as a string;\n  * `:user_id` - creating user ID. RabbitMQ will validate this against the active connection user;\n  * `:app_id` - publishing application ID.","ref":"Amqpx.Basic.html#publish/5-options","title":"Options - Amqpx.Basic.publish/5","type":"function"},{"doc":"iex> Amqpx.Basic.publish chan, \"my_exchange\", \"my_routing_key\", \"Hello World!\", persistent: true\n    :ok","ref":"Amqpx.Basic.html#publish/5-examples","title":"Examples - Amqpx.Basic.publish/5","type":"function"},{"doc":"Sets the message prefetch count or prefetech size (in bytes).","ref":"Amqpx.Basic.html#qos/2","title":"Amqpx.Basic.qos/2","type":"function"},{"doc":"* `:prefetch_size` - the prefetch size (in bytes). Defaults to `0`.\n  * `:prefetch_count` - the prefetch count. Defaults to `0`.\n  * `:global` - If set, this applies to the entire Connection, otherwise\n    it applies only to the given Channel. Defaults to `false`.","ref":"Amqpx.Basic.html#qos/2-options","title":"Options - Amqpx.Basic.qos/2","type":"function"},{"doc":"Asks the server to redeliver all unacknowledged messages on a specified channel.","ref":"Amqpx.Basic.html#recover/2","title":"Amqpx.Basic.recover/2","type":"function"},{"doc":"* `:requeue` - If set, the server will attempt to requeue the message,\n    potentially delivering it to another subscriber. Otherwise it will be redelivered\n    to the original recipient. Defaults to `false`.","ref":"Amqpx.Basic.html#recover/2-options","title":"Options - Amqpx.Basic.recover/2","type":"function"},{"doc":"Rejects (and, optionally, requeues) a message.","ref":"Amqpx.Basic.html#reject/3","title":"Amqpx.Basic.reject/3","type":"function"},{"doc":"* `:requeue` - If set, the message is requeued by the server, otherwise\n    it's discarded. Defaults to `true`.","ref":"Amqpx.Basic.html#reject/3-options","title":"Options - Amqpx.Basic.reject/3","type":"function"},{"doc":"Registers a handler to deal with returned messages.\n\nThe registered process will receive `{:basic_return, payload, meta}` tuples.","ref":"Amqpx.Basic.html#return/2","title":"Amqpx.Basic.return/2","type":"function"},{"doc":"","ref":"Amqpx.Basic.html#t:consumer_tag/0","title":"Amqpx.Basic.consumer_tag/0","type":"type"},{"doc":"","ref":"Amqpx.Basic.html#t:delivery_tag/0","title":"Amqpx.Basic.delivery_tag/0","type":"type"},{"doc":"","ref":"Amqpx.Basic.html#t:error/0","title":"Amqpx.Basic.error/0","type":"type"},{"doc":"","ref":"Amqpx.Basic.html#t:exchange/0","title":"Amqpx.Basic.exchange/0","type":"type"},{"doc":"","ref":"Amqpx.Basic.html#t:payload/0","title":"Amqpx.Basic.payload/0","type":"type"},{"doc":"","ref":"Amqpx.Basic.html#t:queue/0","title":"Amqpx.Basic.queue/0","type":"type"},{"doc":"","ref":"Amqpx.Basic.html#t:routing_key/0","title":"Amqpx.Basic.routing_key/0","type":"type"},{"doc":"Functions to operate on Channels.","ref":"Amqpx.Channel.html","title":"Amqpx.Channel","type":"module"},{"doc":"Closes an open Channel.","ref":"Amqpx.Channel.html#close/1","title":"Amqpx.Channel.close/1","type":"function"},{"doc":"Opens a new Channel in a previously opened Connection.","ref":"Amqpx.Channel.html#open/1","title":"Amqpx.Channel.open/1","type":"function"},{"doc":"","ref":"Amqpx.Channel.html#open/2","title":"Amqpx.Channel.open/2","type":"function"},{"doc":"","ref":"Amqpx.Channel.html#t:t/0","title":"Amqpx.Channel.t/0","type":"type"},{"doc":"Functions that work with publisher confirms (RabbitMQ extension to Amqpx 0.9.1).","ref":"Amqpx.Confirm.html","title":"Amqpx.Confirm","type":"module"},{"doc":"On channel with confirm activated, return the next message sequence number.\nTo use in combination with `register_confirm_handler/2`","ref":"Amqpx.Confirm.html#next_publish_seqno/1","title":"Amqpx.Confirm.next_publish_seqno/1","type":"function"},{"doc":"This registers a handler for confirms on channel.\nThe handler will receive either:\n* `{:basic_ack, seqno, multiple}`\n* `{:basic_nack, seqno, multiple}`\n\nThe `seqno` (delivery_tag) is an integer, the sequence number of the message.\n`multiple` is a boolean, when `true` means multiple messages confirm, upto `seqno`.\nsee https://www.rabbitmq.com/confirms.html","ref":"Amqpx.Confirm.html#register_confirm_handler/2","title":"Amqpx.Confirm.register_confirm_handler/2","type":"function"},{"doc":"This registers a handler to deal with channel flow notifications.","ref":"Amqpx.Confirm.html#register_flow_handler/2","title":"Amqpx.Confirm.register_flow_handler/2","type":"function"},{"doc":"This registers a handler to deal with returned messages.","ref":"Amqpx.Confirm.html#register_return_handler/2","title":"Amqpx.Confirm.register_return_handler/2","type":"function"},{"doc":"Activates publishing confirmations on the channel.","ref":"Amqpx.Confirm.html#select/1","title":"Amqpx.Confirm.select/1","type":"function"},{"doc":"This removes the confirm handler, if it exists. Does nothing if there is no\nsuch handler.","ref":"Amqpx.Confirm.html#unregister_confirm_handler/1","title":"Amqpx.Confirm.unregister_confirm_handler/1","type":"function"},{"doc":"This removes the flow handler, if it exists. Does nothing if there is no\nsuch handler.","ref":"Amqpx.Confirm.html#unregister_flow_handler/1","title":"Amqpx.Confirm.unregister_flow_handler/1","type":"function"},{"doc":"This removes the return handler, if it exists. Does nothing if there is no\nsuch handler.","ref":"Amqpx.Confirm.html#unregister_return_handler/1","title":"Amqpx.Confirm.unregister_return_handler/1","type":"function"},{"doc":"Wait until all messages published since the last call have been\neither ack'd or nack'd by the broker.","ref":"Amqpx.Confirm.html#wait_for_confirms/1","title":"Amqpx.Confirm.wait_for_confirms/1","type":"function"},{"doc":"Wait until all messages published since the last call have been\neither ack'd or nack'd by the broker, or until timeout elapses.","ref":"Amqpx.Confirm.html#wait_for_confirms/2","title":"Amqpx.Confirm.wait_for_confirms/2","type":"function"},{"doc":"Wait until all messages published since the last call have been\neither ack'd or nack'd by the broker, or until timeout elapses.\nIf any of the messages were nack'd, the calling process dies.","ref":"Amqpx.Confirm.html#wait_for_confirms_or_die/1","title":"Amqpx.Confirm.wait_for_confirms_or_die/1","type":"function"},{"doc":"","ref":"Amqpx.Confirm.html#wait_for_confirms_or_die/2","title":"Amqpx.Confirm.wait_for_confirms_or_die/2","type":"function"},{"doc":"Functions to operate on Connections.","ref":"Amqpx.Connection.html","title":"Amqpx.Connection","type":"module"},{"doc":"Closes an open Connection.","ref":"Amqpx.Connection.html#close/1","title":"Amqpx.Connection.close/1","type":"function"},{"doc":"Opens a new connection without a name.\n\nBehaves exactly like `open(options_or_uri, :undefined)`. See `open/2`.","ref":"Amqpx.Connection.html#open/1","title":"Amqpx.Connection.open/1","type":"function"},{"doc":"Opens a new Connection to an Amqpx broker.\n\nThe connections created by this module are supervised under  amqp_client's supervision tree.\nPlease note that connections do not get restarted automatically by the supervision tree in\ncase of a failure. If you need robust connections and channels, use monitors on the returned\nconnection PID.\n\nThis function can be called in three ways:\n\n  * with a list of options and a name\n  * with an Amqpx URI and a name\n  * with an Amqpx URI and a list of options (in this case, the options are merged with\n    the Amqpx URI, taking precedence on same keys)","ref":"Amqpx.Connection.html#open/2","title":"Amqpx.Connection.open/2","type":"function"},{"doc":"* `:username` - The name of a user registered with the broker (defaults to `\"guest\"`);\n  * `:password` - The password of user (defaults to `\"guest\"`);\n  * `:virtual_host` - The name of a virtual host in the broker (defaults to `\"/\"`);\n  * `:host` - The hostname of the broker (defaults to `\"localhost\"`);\n  * `:port` - The port the broker is listening on (defaults to `5672`);\n  * `:channel_max` - The channel_max handshake parameter (defaults to `0`);\n  * `:frame_max` - The frame_max handshake parameter (defaults to `0`);\n  * `:heartbeat` - The hearbeat interval in seconds (defaults to `10`);\n  * `:connection_timeout` - The connection timeout in milliseconds (defaults to `50000`);\n  * `:ssl_options` - Enable SSL by setting the location to cert files (defaults to `:none`);\n  * `:client_properties` - A list of extra client properties to be sent to the server, defaults to `[]`;\n  * `:socket_options` - Extra socket options. These are appended to the default options.                         See http://www.erlang.org/doc/man/inet.html#setopts-2 and http://www.erlang.org/doc/man/gen_tcp.html#connect-4                         for descriptions of the available options.","ref":"Amqpx.Connection.html#open/2-options","title":"Options - Amqpx.Connection.open/2","type":"function"},{"doc":"To enable SSL, supply the following in the `ssl_options` field:\n\n  * `cacertfile` - Specifies the certificates of the root Certificate Authorities that we wish to implicitly trust;\n  * `certfile` - The client's own certificate in PEM format;\n  * `keyfile` - The client's private key in PEM format;","ref":"Amqpx.Connection.html#open/2-enabling-ssl","title":"Enabling SSL - Amqpx.Connection.open/2","type":"function"},{"doc":"```\nAmqpx.Connection.open port: 5671,\n                     ssl_options: [cacertfile: '/path/to/testca/cacert.pem',\n                                   certfile: '/path/to/client/cert.pem',\n                                   keyfile: '/path/to/client/key.pem',\n                                   # only necessary with intermediate CAs\n                                   # depth: 2,\n                                   verify: :verify_peer,\n                                   fail_if_no_peer_cert: true]\n```","ref":"Amqpx.Connection.html#open/2-example","title":"Example - Amqpx.Connection.open/2","type":"function"},{"doc":"RabbitMQ supports user-specified connection names since version 3.6.2.\n\nConnection names are human-readable strings that will be displayed in the management UI.\nConnection names do not have to be unique and cannot be used as connection identifiers.\n\nIf the name is `:undefined`, the connection is not registered with any name.","ref":"Amqpx.Connection.html#open/2-connection-name","title":"Connection name - Amqpx.Connection.open/2","type":"function"},{"doc":"iex> options = [host: \"localhost\", port: 5672, virtual_host: \"/\", username: \"guest\", password: \"guest\"]\n    iex> Amqpx.Connection.open(options, :undefined)\n    {:ok, %Amqpx.Connection{}}\n\n    iex> Amqpx.Connection.open(\"amqp://guest:guest@localhost\", port: 5673)\n    {:ok, %Amqpx.Connection{}}\n\n    iex> Amqpx.Connection.open(\"amqp://guest:guest@localhost\", \"a-connection-with-a-name\")\n    {:ok, %Amqpx.Connection{}}","ref":"Amqpx.Connection.html#open/2-examples","title":"Examples - Amqpx.Connection.open/2","type":"function"},{"doc":"Opens a new connection with a name, merging the given Amqpx URI and options.\n\nThis function opens a new connection by merging the given Amqpx URI `uri` and\nthe given `options` and assigns it the name `name`.\n\nThe options in `options` take precedence over the values in `uri`.\n\nSee `open/2` for options.","ref":"Amqpx.Connection.html#open/3","title":"Amqpx.Connection.open/3","type":"function"},{"doc":"iex> Amqpx.Connection.open(\"amqp://guest:guest@localhost\", \"a-connection-name\", port: 5673)\n    {:ok, %Amqpx.Connection{}}","ref":"Amqpx.Connection.html#open/3-examples","title":"Examples - Amqpx.Connection.open/3","type":"function"},{"doc":"","ref":"Amqpx.Connection.html#t:t/0","title":"Amqpx.Connection.t/0","type":"type"},{"doc":"Module to resolve a DNS record into an A record.","ref":"Amqpx.DNS.html","title":"Amqpx.DNS","type":"module"},{"doc":"Resolves the IP addresses of a given hostname. If the hostname\ncannot be resolved, it returns the hostname itself.","ref":"Amqpx.DNS.html#resolve_ips/1","title":"Amqpx.DNS.resolve_ips/1","type":"function"},{"doc":"This module \"wraps\" the [amqp_direct_consumer](https://github.com/rabbitmq/rabbitmq-server/blob/main/deps/amqp_client/src/amqp_direct_consumer.erl) module to manage the race condition that occurs at supervisor shutdown, leading to error logs such as:\n```\n[error] GenServer #PID<0.846.0> terminating\n** (stop) {:error, {:consumer_died, :shutdown}}\nLast message: {:DOWN, #Reference<0.1010163881.3799777283.106124>, :process, #PID<0.798.0>, :shutdown}.\n```\nThe reason for this behavior is that the `amqp_direct_consumer` module considers any exit reason other than `:normal` as an error, prompting it to exit.\nIn our implementation, we have introduced two pattern matches to treat the exit reasons `:shutdown` and `{:shutdown, reason}` as normal occurrences; these conditions typically arise when the supervisor terminates the consumer, such as during a standard shutdown of the application.\"","ref":"Amqpx.DirectConsumer.html","title":"Amqpx.DirectConsumer","type":"module"},{"doc":"","ref":"Amqpx.DirectConsumer.html#handle_call/3","title":"Amqpx.DirectConsumer.handle_call/3","type":"function"},{"doc":"","ref":"Amqpx.DirectConsumer.html#handle_cancel/2","title":"Amqpx.DirectConsumer.handle_cancel/2","type":"function"},{"doc":"","ref":"Amqpx.DirectConsumer.html#handle_cancel_ok/3","title":"Amqpx.DirectConsumer.handle_cancel_ok/3","type":"function"},{"doc":"","ref":"Amqpx.DirectConsumer.html#handle_consume/3","title":"Amqpx.DirectConsumer.handle_consume/3","type":"function"},{"doc":"","ref":"Amqpx.DirectConsumer.html#handle_consume_ok/3","title":"Amqpx.DirectConsumer.handle_consume_ok/3","type":"function"},{"doc":"","ref":"Amqpx.DirectConsumer.html#handle_deliver/3","title":"Amqpx.DirectConsumer.handle_deliver/3","type":"function"},{"doc":"","ref":"Amqpx.DirectConsumer.html#handle_deliver/4","title":"Amqpx.DirectConsumer.handle_deliver/4","type":"function"},{"doc":"","ref":"Amqpx.DirectConsumer.html#handle_info/2","title":"Amqpx.DirectConsumer.handle_info/2","type":"function"},{"doc":"","ref":"Amqpx.DirectConsumer.html#handle_server_cancel/2","title":"Amqpx.DirectConsumer.handle_server_cancel/2","type":"function"},{"doc":"","ref":"Amqpx.DirectConsumer.html#init/1","title":"Amqpx.DirectConsumer.init/1","type":"function"},{"doc":"","ref":"Amqpx.DirectConsumer.html#terminate/2","title":"Amqpx.DirectConsumer.terminate/2","type":"function"},{"doc":"Functions to operate on Exchanges.","ref":"Amqpx.Exchange.html","title":"Amqpx.Exchange","type":"module"},{"doc":"Binds an Exchange to another Exchange using the\nexchange.bind Amqpx method (a RabbitMQ-specific extension).","ref":"Amqpx.Exchange.html#bind/4","title":"Amqpx.Exchange.bind/4","type":"function"},{"doc":"* `:routing_key` - the routing key to use for the binding. Defaults to `\"\"`.\n  * `:no_wait` - If set, the bind operation is asynchronous. Defaults to\n    `false`.\n  * `:arguments` - A list of arguments to pass when binding (of type `t:Amqpx.arguments/0`).\n    See the README for more information. Defaults to `[]`.","ref":"Amqpx.Exchange.html#bind/4-options","title":"Options - Amqpx.Exchange.bind/4","type":"function"},{"doc":"Declares an Exchange. The default Exchange type is `direct`.\n\nAmqpx 0-9-1 brokers provide four pre-declared exchanges:\n\n*   `:direct` exchange: (empty string) or `amq.direct`\n*   `:fanout` exchange: `amq.fanout`\n*   `:topic` exchange: `amq.topic`\n*   `:headers` exchange: `amq.match` (and `amq.headers` in RabbitMQ)\n\nBesides the exchange name and type, the following options can be used:","ref":"Amqpx.Exchange.html#declare/4","title":"Amqpx.Exchange.declare/4","type":"function"},{"doc":"* `:durable` - If set, keeps the Exchange between restarts of the broker;\n  * `:auto_delete` - If set, deletes the Exchange once all queues unbind from it;\n  * `:passive` - If set, returns an error if the Exchange does not already exist;\n  * `:internal` - If set, the exchange may not be used directly by publishers, but only when bound to other exchanges. Internal exchanges are used to construct wiring that is not visible to applications.\n  * `:no_wait` - If set, the declare operation is asynchronous. Defaults to\n    `false`.\n  * `:arguments` - A list of arguments to pass when declaring (of type `t:Amqpx.arguments/0`).\n    See the README for more information. Defaults to `[]`.","ref":"Amqpx.Exchange.html#declare/4-options","title":"Options - Amqpx.Exchange.declare/4","type":"function"},{"doc":"Deletes an Exchange by name. When an Exchange is deleted all bindings to it are\nalso deleted.","ref":"Amqpx.Exchange.html#delete/3","title":"Amqpx.Exchange.delete/3","type":"function"},{"doc":"* `:if_unused` - If set, the server will only delete the exchange if it has no queue\n    bindings.\n  * `:no_wait` - If set, the delete operation is asynchronous. Defaults to\n    `false`.","ref":"Amqpx.Exchange.html#delete/3-options","title":"Options - Amqpx.Exchange.delete/3","type":"function"},{"doc":"Convenience function to declare an Exchange of type `direct`.","ref":"Amqpx.Exchange.html#direct/3","title":"Amqpx.Exchange.direct/3","type":"function"},{"doc":"This function takes the same options as `declare/4`.","ref":"Amqpx.Exchange.html#direct/3-options","title":"Options - Amqpx.Exchange.direct/3","type":"function"},{"doc":"Convenience function to declare an Exchange of type `fanout`.","ref":"Amqpx.Exchange.html#fanout/3","title":"Amqpx.Exchange.fanout/3","type":"function"},{"doc":"This function takes the same options as `declare/4`.","ref":"Amqpx.Exchange.html#fanout/3-options","title":"Options - Amqpx.Exchange.fanout/3","type":"function"},{"doc":"Convenience function to declare an Exchange of type `topic`.","ref":"Amqpx.Exchange.html#topic/3","title":"Amqpx.Exchange.topic/3","type":"function"},{"doc":"This function takes the same options as `declare/4`.","ref":"Amqpx.Exchange.html#topic/3-options","title":"Options - Amqpx.Exchange.topic/3","type":"function"},{"doc":"Unbinds an Exchange from another Exchange or a Queue using the\nexchange.unbind Amqpx method (a RabbitMQ-specific extension).","ref":"Amqpx.Exchange.html#unbind/4","title":"Amqpx.Exchange.unbind/4","type":"function"},{"doc":"* `:routing_key` - the routing key to use for the binding. Defaults to `\"\"`.\n  * `:no_wait` - If set, the declare operation is asynchronous. Defaults to\n    `false`.\n  * `:arguments` - A list of arguments to pass when declaring (of type `t:Amqpx.arguments/0`).\n    See the README for more information. Defaults to `[]`.","ref":"Amqpx.Exchange.html#unbind/4-options","title":"Options - Amqpx.Exchange.unbind/4","type":"function"},{"doc":"Handle connection for all consumers and producer","ref":"Amqpx.Gen.ConnectionManager.html","title":"Amqpx.Gen.ConnectionManager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Amqpx.Gen.ConnectionManager.html#child_spec/1","title":"Amqpx.Gen.ConnectionManager.child_spec/1","type":"function"},{"doc":"","ref":"Amqpx.Gen.ConnectionManager.html#init/1","title":"Amqpx.Gen.ConnectionManager.init/1","type":"function"},{"doc":"","ref":"Amqpx.Gen.ConnectionManager.html#start_link/1","title":"Amqpx.Gen.ConnectionManager.start_link/1","type":"function"},{"doc":"","ref":"Amqpx.Gen.ConnectionManager.html#t:state/0","title":"Amqpx.Gen.ConnectionManager.state/0","type":"type"},{"doc":"Generic implementation of amqp consumer","ref":"Amqpx.Gen.Consumer.html","title":"Amqpx.Gen.Consumer","type":"behaviour"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Amqpx.Gen.Consumer.html#child_spec/1","title":"Amqpx.Gen.Consumer.child_spec/1","type":"function"},{"doc":"","ref":"Amqpx.Gen.Consumer.html#c:handle_message/3","title":"Amqpx.Gen.Consumer.handle_message/3","type":"callback"},{"doc":"","ref":"Amqpx.Gen.Consumer.html#c:handle_message_rejection/2","title":"Amqpx.Gen.Consumer.handle_message_rejection/2","type":"callback"},{"doc":"","ref":"Amqpx.Gen.Consumer.html#init/1","title":"Amqpx.Gen.Consumer.init/1","type":"function"},{"doc":"","ref":"Amqpx.Gen.Consumer.html#c:setup/1","title":"Amqpx.Gen.Consumer.setup/1","type":"callback"},{"doc":"","ref":"Amqpx.Gen.Consumer.html#start_link/1","title":"Amqpx.Gen.Consumer.start_link/1","type":"function"},{"doc":"","ref":"Amqpx.Gen.Consumer.html#t:signal_status/0","title":"Amqpx.Gen.Consumer.signal_status/0","type":"type"},{"doc":"","ref":"Amqpx.Gen.Consumer.html#t:state/0","title":"Amqpx.Gen.Consumer.state/0","type":"type"},{"doc":"Generic implementation of amqp producer","ref":"Amqpx.Gen.Producer.html","title":"Amqpx.Gen.Producer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Amqpx.Gen.Producer.html#child_spec/1","title":"Amqpx.Gen.Producer.child_spec/1","type":"function"},{"doc":"","ref":"Amqpx.Gen.Producer.html#do_publish_by/6","title":"Amqpx.Gen.Producer.do_publish_by/6","type":"function"},{"doc":"","ref":"Amqpx.Gen.Producer.html#init/1","title":"Amqpx.Gen.Producer.init/1","type":"function"},{"doc":"","ref":"Amqpx.Gen.Producer.html#publish/4","title":"Amqpx.Gen.Producer.publish/4","type":"function"},{"doc":"","ref":"Amqpx.Gen.Producer.html#publish_by/5","title":"Amqpx.Gen.Producer.publish_by/5","type":"function"},{"doc":"","ref":"Amqpx.Gen.Producer.html#start_link/1","title":"Amqpx.Gen.Producer.start_link/1","type":"function"},{"doc":"","ref":"Amqpx.Gen.Producer.html#t:state/0","title":"Amqpx.Gen.Producer.state/0","type":"type"},{"doc":"Helper functions","ref":"Amqpx.Helper.html","title":"Amqpx.Helper","type":"module"},{"doc":"","ref":"Amqpx.Helper.html#consumers_supervisor_configuration/1","title":"Amqpx.Helper.consumers_supervisor_configuration/1","type":"function"},{"doc":"","ref":"Amqpx.Helper.html#declare/2","title":"Amqpx.Helper.declare/2","type":"function"},{"doc":"","ref":"Amqpx.Helper.html#encrypt_password/1","title":"Amqpx.Helper.encrypt_password/1","type":"function"},{"doc":"","ref":"Amqpx.Helper.html#get_password/2","title":"Amqpx.Helper.get_password/2","type":"function"},{"doc":"","ref":"Amqpx.Helper.html#manager_supervisor_configuration/1","title":"Amqpx.Helper.manager_supervisor_configuration/1","type":"function"},{"doc":"","ref":"Amqpx.Helper.html#producer_supervisor_configuration/1","title":"Amqpx.Helper.producer_supervisor_configuration/1","type":"function"},{"doc":"","ref":"Amqpx.Helper.html#setup_dead_lettering/2","title":"Amqpx.Helper.setup_dead_lettering/2","type":"function"},{"doc":"","ref":"Amqpx.Helper.html#setup_exchange/2","title":"Amqpx.Helper.setup_exchange/2","type":"function"},{"doc":"","ref":"Amqpx.Helper.html#setup_exchange/3","title":"Amqpx.Helper.setup_exchange/3","type":"function"},{"doc":"","ref":"Amqpx.Helper.html#setup_queue/2","title":"Amqpx.Helper.setup_queue/2","type":"function"},{"doc":"Functions to operate on Queues.","ref":"Amqpx.Queue.html","title":"Amqpx.Queue","type":"module"},{"doc":"Binds a Queue to an Exchange.","ref":"Amqpx.Queue.html#bind/4","title":"Amqpx.Queue.bind/4","type":"function"},{"doc":"* `:routing_key` - The routing key used to bind the queue to the exchange.\n    Defaults to `\"\"`.\n  * `:no_wait` - If `true`, the binding is not synchronous. Defaults to `false`.\n  * `:arguments` - A list of arguments to pass when binding (of type `t:Amqpx.arguments/0`).\n    See the README for more information. Defaults to `[]`.","ref":"Amqpx.Queue.html#bind/4-options","title":"Options - Amqpx.Queue.bind/4","type":"function"},{"doc":"Returns a number of active consumers on the queue.","ref":"Amqpx.Queue.html#consumer_count/2","title":"Amqpx.Queue.consumer_count/2","type":"function"},{"doc":"Declares a queue. The optional `queue` parameter is used to set the name.\nIf set to an empty string (default), the server will assign a name.\n\nBesides the queue name, the following options can be used:","ref":"Amqpx.Queue.html#declare/3","title":"Amqpx.Queue.declare/3","type":"function"},{"doc":"* `:durable` - If set, keeps the Queue between restarts of the broker.\n    Defaults to `false`.\n  * `:auto_delete` - If set, deletes the Queue once all subscribers disconnect.\n    Defaults to `false`.\n  * `:exclusive` - If set, only one subscriber can consume from the Queue.\n    Defaults to `false`.\n  * `:passive` - If set, raises an error unless the queue already exists.\n    Defaults to `false`.\n  * `:no_wait` - If set, the declare operation is asynchronous. Defaults to\n    `false`.\n  * `:arguments` - A list of arguments to pass when declaring (of type `t:Amqpx.arguments/0`).\n    See the README for more information. Defaults to `[]`.","ref":"Amqpx.Queue.html#declare/3-options","title":"Options - Amqpx.Queue.declare/3","type":"function"},{"doc":"Deletes a Queue by name.","ref":"Amqpx.Queue.html#delete/3","title":"Amqpx.Queue.delete/3","type":"function"},{"doc":"* `:if_unused` - If set, the server will only delete the queue if it has no\n    consumers. If the queue has consumers, it's not deleted and an error is\n    returned.\n  * `:if_empty` - If set, the server will only delete the queue if it has no messages.\n  * `:no_wait` - If set, the delete operation is asynchronous.","ref":"Amqpx.Queue.html#delete/3-options","title":"Options - Amqpx.Queue.delete/3","type":"function"},{"doc":"Returns true if queue is empty (has no messages ready), false otherwise.","ref":"Amqpx.Queue.html#empty?/2","title":"Amqpx.Queue.empty?/2","type":"function"},{"doc":"Returns the number of messages that are ready for delivery (e.g. not pending acknowledgements)\nin the queue.","ref":"Amqpx.Queue.html#message_count/2","title":"Amqpx.Queue.message_count/2","type":"function"},{"doc":"Discards all messages in the Queue.","ref":"Amqpx.Queue.html#purge/2","title":"Amqpx.Queue.purge/2","type":"function"},{"doc":"Returns the message count and consumer count for the given queue.\nUses `declare/3` with the `:passive` option set.","ref":"Amqpx.Queue.html#status/2","title":"Amqpx.Queue.status/2","type":"function"},{"doc":"Convenience to consume messages from a Queue.\n\nThe handler function must have arity 2 and will receive as arguments a binary with the message payload\nand a Map with the message properties.\n\nThe consumed message will be acknowledged after executing the handler function.\nIf an exception is raised by the handler function, the message is rejected.\n\nThis convenience function will spawn a process and register it using Amqpx.Basic.consume.","ref":"Amqpx.Queue.html#subscribe/3","title":"Amqpx.Queue.subscribe/3","type":"function"},{"doc":"Unbinds a Queue from an Exchange.","ref":"Amqpx.Queue.html#unbind/4","title":"Amqpx.Queue.unbind/4","type":"function"},{"doc":"* `:routing_key` - The routing queue for removing the binding. Defaults to `\"\"`.\n  * `:arguments` - A list of arguments to pass when unbinding (of type `t:Amqpx.arguments/0`).\n    See the README for more information. Defaults to `[]`.","ref":"Amqpx.Queue.html#unbind/4-options","title":"Options - Amqpx.Queue.unbind/4","type":"function"},{"doc":"Stops the consumer identified by `consumer_tag` from consuming.\n\nInternally just calls `Amqpx.Basic.cancel/2`.","ref":"Amqpx.Queue.html#unsubscribe/2","title":"Amqpx.Queue.unsubscribe/2","type":"function"},{"doc":"This module is responsible for handling signals sent to the application.","ref":"Amqpx.SignalHandler.html","title":"Amqpx.SignalHandler","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Amqpx.SignalHandler.html#child_spec/1","title":"Amqpx.SignalHandler.child_spec/1","type":"function"},{"doc":"","ref":"Amqpx.SignalHandler.html#draining/0","title":"Amqpx.SignalHandler.draining/0","type":"function"},{"doc":"","ref":"Amqpx.SignalHandler.html#get_signal_status/0","title":"Amqpx.SignalHandler.get_signal_status/0","type":"function"},{"doc":"","ref":"Amqpx.SignalHandler.html#init/1","title":"Amqpx.SignalHandler.init/1","type":"function"},{"doc":"","ref":"Amqpx.SignalHandler.html#start_link/0","title":"Amqpx.SignalHandler.start_link/0","type":"function"},{"doc":"","ref":"Amqpx.SignalHandler.html#stopping/0","title":"Amqpx.SignalHandler.stopping/0","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.Consumer1.html","title":"Amqpx.Test.Support.Consumer1","type":"module"},{"doc":"","ref":"Amqpx.Test.Support.Consumer1.html#handle_message/3","title":"Amqpx.Test.Support.Consumer1.handle_message/3","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.Consumer1.html#setup/1","title":"Amqpx.Test.Support.Consumer1.setup/1","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.Consumer2.html","title":"Amqpx.Test.Support.Consumer2","type":"module"},{"doc":"","ref":"Amqpx.Test.Support.Consumer2.html#handle_message/3","title":"Amqpx.Test.Support.Consumer2.handle_message/3","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.Consumer2.html#setup/1","title":"Amqpx.Test.Support.Consumer2.setup/1","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.Consumer3.html","title":"Amqpx.Test.Support.Consumer3","type":"module"},{"doc":"","ref":"Amqpx.Test.Support.Consumer3.html#handle_message/3","title":"Amqpx.Test.Support.Consumer3.handle_message/3","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.Consumer3.html#setup/1","title":"Amqpx.Test.Support.Consumer3.setup/1","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.ConsumerConnectionTwo.html","title":"Amqpx.Test.Support.ConsumerConnectionTwo","type":"module"},{"doc":"","ref":"Amqpx.Test.Support.ConsumerConnectionTwo.html#handle_message/3","title":"Amqpx.Test.Support.ConsumerConnectionTwo.handle_message/3","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.ConsumerConnectionTwo.html#setup/1","title":"Amqpx.Test.Support.ConsumerConnectionTwo.setup/1","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.HandleRejectionConsumer.html","title":"Amqpx.Test.Support.HandleRejectionConsumer","type":"module"},{"doc":"","ref":"Amqpx.Test.Support.HandleRejectionConsumer.html#handle_message/3","title":"Amqpx.Test.Support.HandleRejectionConsumer.handle_message/3","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.HandleRejectionConsumer.html#handle_message_rejection/2","title":"Amqpx.Test.Support.HandleRejectionConsumer.handle_message_rejection/2","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.HandleRejectionConsumer.html#setup/1","title":"Amqpx.Test.Support.HandleRejectionConsumer.setup/1","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.NoRequeueConsumer.html","title":"Amqpx.Test.Support.NoRequeueConsumer","type":"module"},{"doc":"","ref":"Amqpx.Test.Support.NoRequeueConsumer.html#handle_message/3","title":"Amqpx.Test.Support.NoRequeueConsumer.handle_message/3","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.NoRequeueConsumer.html#handle_message_rejection/2","title":"Amqpx.Test.Support.NoRequeueConsumer.handle_message_rejection/2","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.NoRequeueConsumer.html#setup/1","title":"Amqpx.Test.Support.NoRequeueConsumer.setup/1","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.Producer1.html","title":"Amqpx.Test.Support.Producer1","type":"module"},{"doc":"","ref":"Amqpx.Test.Support.Producer1.html#send_payload/1","title":"Amqpx.Test.Support.Producer1.send_payload/1","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.Producer2.html","title":"Amqpx.Test.Support.Producer2","type":"module"},{"doc":"","ref":"Amqpx.Test.Support.Producer2.html#send_payload/1","title":"Amqpx.Test.Support.Producer2.send_payload/1","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.Producer3.html","title":"Amqpx.Test.Support.Producer3","type":"module"},{"doc":"","ref":"Amqpx.Test.Support.Producer3.html#send_payload/1","title":"Amqpx.Test.Support.Producer3.send_payload/1","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.ProducerConnectionTwo.html","title":"Amqpx.Test.Support.ProducerConnectionTwo","type":"module"},{"doc":"","ref":"Amqpx.Test.Support.ProducerConnectionTwo.html#send_payload/1","title":"Amqpx.Test.Support.ProducerConnectionTwo.send_payload/1","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.ProducerWithRetry.html","title":"Amqpx.Test.Support.ProducerWithRetry","type":"module"},{"doc":"","ref":"Amqpx.Test.Support.ProducerWithRetry.html#send_payload_with_jittered_backoff/1","title":"Amqpx.Test.Support.ProducerWithRetry.send_payload_with_jittered_backoff/1","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.ProducerWithRetry.html#send_payload_with_publish_confirm_delivery_timeout/1","title":"Amqpx.Test.Support.ProducerWithRetry.send_payload_with_publish_confirm_delivery_timeout/1","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.ProducerWithRetry.html#send_payload_with_publish_confirm_delivery_timeout_and_on_publish_error/1","title":"Amqpx.Test.Support.ProducerWithRetry.send_payload_with_publish_confirm_delivery_timeout_and_on_publish_error/1","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.ProducerWithRetry.html#send_payload_with_publish_error/1","title":"Amqpx.Test.Support.ProducerWithRetry.send_payload_with_publish_error/1","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.ProducerWithRetry.html#send_payload_with_publish_rejected/1","title":"Amqpx.Test.Support.ProducerWithRetry.send_payload_with_publish_rejected/1","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.ProducerWithRetry.html#send_payload_without_publish_error/1","title":"Amqpx.Test.Support.ProducerWithRetry.send_payload_without_publish_error/1","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.ProducerWithRetry.html#send_payload_without_publish_rejected/1","title":"Amqpx.Test.Support.ProducerWithRetry.send_payload_without_publish_rejected/1","type":"function"},{"doc":"Raised when the connection is closed or blocked.","ref":"Amqpx.BasicError.html","title":"Amqpx.BasicError","type":"exception"}],"producer":{"name":"ex_doc","version":"0.35.1"},"proglang":"elixir"}